module JavaClassField (module JavaClassField) where

import JavaClassFieldVisibility (JavaClassFieldVisibility)
import PrimitiveTypes (PrimitiveType)
import ClassTypeParameter (ClassType, ArrayType)
import JavaVariableInitializer (JavaVariableInitializer)

import Data.Set (Set)

data JavaClassField = JavaClassField { name :: String
        , visiblity   :: JavaClassFieldVisibility
        , modifiers   :: Set JavaClassFieldModifier
        , type_       :: JavaClassFieldType
        , initializer :: Maybe JavaVariableInitializer
        }
        deriving Show

data JavaClassFieldModifier = Static 
        | Final 
        | Transient 
        | Volatile
        deriving (Show, Ord, Eq)

data JavaClassFieldType = PrimitiveFieldType PrimitiveType 
        | ClassFieldType ClassType 
        | VariableFieldType String 
        | ArrayFieldType ArrayType
        deriving Show
