module JavaLanguage 
( javaLanguageDef
, m_paren
, m_identifier
, m_reserved
, m_lexeme
, m_symbol
, m_commaSep1
, m_commaSep
, m_angles
, m_braces
, m_reservedOp
) where

import Text.Parsec
import Text.Parsec.Language
import Text.Parsec.Token

import Data.Functor.Identity

javaLanguageDef :: GenLanguageDef String u Identity
javaLanguageDef = emptyDef{ commentStart = "/*"
              , commentEnd = "*/"
              , commentLine = "//"
              , nestedComments = False
              , identStart = letter <|> char '_'
              , identLetter = alphaNum <|> char '_'
              , opStart = oneOf ".+-*/;"
              , opLetter = oneOf ".+-*/;"
              , reservedOpNames = [";"]
              , reservedNames = [ "true"
                , "false"
                , "package"
                , "class"
                , "interface"
                , "void"
                , "boolean"
                , "char"
                , "short"
                , "int"
                , "float"
                , "long"
                , "double"
                , "instanceof"
                , "public"
                , "private"
                , "protected"
                , "static"
                , "final"
                , "volatile"
                , "transient"
                ]
              , caseSensitive = True
              }

TokenParser{ parens = m_paren
        , identifier = m_identifier 
        , reserved   = m_reserved
        , lexeme     = m_lexeme
        , symbol     = m_symbol
        , commaSep1  = m_commaSep1
        , commaSep   = m_commaSep
        , angles     = m_angles
        , braces     = m_braces
        , reservedOp = m_reservedOp } = makeTokenParser javaLanguageDef
