module PrimitiveTypes 
        ( PrimitiveType(..)
        , primitiveType
        ) where

import JavaLanguage (m_reserved)

import Text.Parsec (choice)
import Text.Parsec.String (Parser)

data PrimitiveType = PrimitiveBoolean | PrimitiveByte | PrimitiveShort | PrimitiveInt | PrimitiveLong | PrimitiveChar | PrimitiveFloat | PrimitiveDouble
        deriving Show

primitiveType :: Parser PrimitiveType
primitiveType = choice [ 
          m_reserved "boolean" *> return PrimitiveTypes.PrimitiveBoolean
        , m_reserved "byte"    *> return PrimitiveTypes.PrimitiveByte
        , m_reserved "char"    *> return PrimitiveTypes.PrimitiveChar
        , m_reserved "short"   *> return PrimitiveTypes.PrimitiveShort
        , m_reserved "int"     *> return PrimitiveTypes.PrimitiveInt
        , m_reserved "float"   *> return PrimitiveTypes.PrimitiveFloat
        , m_reserved "long"    *> return PrimitiveTypes.PrimitiveLong
        , m_reserved "double"  *> return PrimitiveTypes.PrimitiveDouble
        ]

